package com.java2s.common;

import java.util.Arrays;
import java.util.Date;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import org.springframework.transaction.annotation.Transactional;

@Transactional
public class PersonDaoImpl {
  public void test() {
    Employee emp = new Employee();
    emp.setName("Tom");
    emp.setSalary(123);
    emp.setStartDate(new Date());
    emp.setId(1);

    Project pro = new Project();
    pro.setName("Design");
    pro.getEmployees().add(emp);

    Department dept = new Department();
    dept.setName("Dept");
    dept.getEmployees().add(emp);

    emp.setDepartment(dept);
    emp.getProjects().add(pro);

    em.persist(dept);
    em.persist(pro);
    em.persist(emp);

    executeAndPrintQuery("SELECT NEW com.java2s.common.EmployeeDetails(e.name, e.salary, e.department.name) FROM Employee e");
  }
  private void executeAndPrintQuery(String queryString) {
    try {
        Query query = em.createQuery(queryString);
        printQueryResult(queryString, query.getResultList());
    } finally {
        em.close();
    }
}
  private void printQueryResult(String queryString, List result) {
    System.out.println("EJB QL: " + queryString+"\n");
    System.out.println("Result:\n");
    if (result.isEmpty()) {
        System.out.println("No results Found\n");
    } else {
        for (Object o : result) {
            System.out.println(resultAsString(o));
        }
    }
  }
  private String resultAsString(Object o) {
    if (o instanceof Object[]) {
        return Arrays.asList((Object[])o).toString();
    } else {
        return String.valueOf(o);
    }
}
  @PersistenceContext
  private EntityManager em;
}
class EmployeeDetails {
  private String name;
  private long salary;
  private String deptName;
  
  public EmployeeDetails(String name, long salary, String deptName) {
      this.name = name;
      this.salary = salary;
      this.deptName = deptName;
  }
  
  public String toString() {
      return "EmployeeDetails name: " + name +
             ", salary: " + salary +
             ", deptName: " + deptName;
  }
}
